package com.example.springbootjavamailsender.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.io.*;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.mail.javamail.MimeMessageHelper;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.activation.DataSource;
import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeUtility;
import java.io.*;
import java.util.Date;
import java.util.Objects;


@RestController
@RequestMapping("/mail")
public class SendMailController {

    @Autowired
    JavaMailSender javaMailSender;

    @Value("${spring.mail.username}") //读取配置文件
    private String from;

    @Autowired
    ResourceLoader resourceLoader;

    @GetMapping("/send")
    public void Send() throws IOException {
        // 发邮件逻辑
        MimeMessage mimeMessage = javaMailSender.createMimeMessage();
        MimeMessageHelper mimeMessageHelper;
        String text = "我是正文";
        String subject = "标题";
        String to = ""; //目标地址
        try {
            mimeMessageHelper = new MimeMessageHelper(mimeMessage, true, "UTF-8");
            mimeMessageHelper.setFrom(from);
            mimeMessageHelper.setTo(to);
            mimeMessageHelper.setSentDate(new Date());
            mimeMessageHelper.setSubject(subject);
            mimeMessageHelper.setText(text);
            //发送附件
            Resource resource = resourceLoader.getResource("classpath:attachment/exp.html");
            mimeMessageHelper.addAttachment("exp.html",  resource);
            //正文中插入图片
            mimeMessageHelper.setText("<html><body><img src='cid:identifier1234'></body></html>", true);
            Resource resource2 = resourceLoader.getResource("classpath:attachment/att.png");
            mimeMessageHelper.addInline("identifier1234", resource2);

            javaMailSender.send(mimeMessage);
        } catch (MessagingException e) {
            System.out.print("发送邮件失败");
        }
        System.out.print("测试");
    }
}
